︠374eb4dd-7ee6-4c8c-829c-1423fbd3f809s︠
reset
︡1d2192a1-fc99-4d34-83fc-c31c5ac70bb8︡{"stdout":"<function reset at 0x7f80c5c78050>\n"}︡{"done":true}
︠1a867174-4915-456f-9e96-25a742bd3dd8︠

︡b42461c8-17e8-463f-8d31-3baf643cf2a0︡
︠22d8c61f-3846-4bcb-bc8d-cb6a4c49a7d1s︠
#Useful commands
#Dot product
var('a b c d');
u=vector((a,b)); v=vector((c,d))# Syntax for defining vectors u, v
u.dot_product(v)# syntax for the dot product <u,v>

︡64eb3032-2070-464b-99bb-5510d6187a7a︡{"stdout":"(a, b, c, d)\n"}︡{"stdout":"a*c + b*d\n"}︡{"done":true}
︠9b3eb4bd-f12d-4720-b142-824ae1dff5e7s︠
norm(vector((3,4)))# magnitude,or length, of the vector
︡10f67438-5933-4ba0-a97f-3b51907f0bf0︡{"stdout":"5\n"}︡{"done":true}
︠87a824dd-e9d0-4ab0-bc62-336a0e34a8b7s︠
#Alternatively,the norm of a vector v can be found "from scratch" as (v.dot_product(v))^0.5

︡c98cd478-8b85-487b-bdbf-37aa3e9eadcf︡{"done":true}
︠8440aa64-5c0a-404e-bd5d-05df14b73331s︠
arrow((3,4),(3+2,4-1),figsize=[3,2])# Syntax for plotting a vector
︡e270ae60-c7ad-4077-a45c-98b94fc3be1f︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/353/tmp_rGwWpE.svg","show":true,"text":null,"uuid":"3388d8f6-9b46-41d7-b281-23506423d20c"},"once":false}︡{"done":true}
︠56fcd9cc-f524-4461-bbc6-2fa979eabb39︠
︡9009d9d3-c891-465c-b2db-4634b40932ff︡
︠e751efc0-57ae-45bf-8815-ba77ec109cb9s︠
search_doc("normal")
norm
︡9be97d39-db8e-47c6-a705-58c28f8615b3︡{"html":"Use this link to search: <a href=\"https://www.google.com/search?q=site%3Adoc.sagemath.org+normal&oq=site%3Adoc.sagemath.org\">normal</a>"}︡{"stdout":"<function norm at 0x7fa59fc20668>\n"}︡{"done":true}
︠1743b29d-bd3f-479e-a078-16e1999b7a8es︠
#Exercise 1. Make a CAS function angle_and_proj(u,v) that takes two list of length 2 each, makes the lists into 2D vectors and returns
#• the angle between the vectors (in radians)
#• the projection of the first vector on the direction of the second vector
#Test your code on example of your choice.
︡39887e1a-8511-4ac1-b3a4-6aeeb7eeeea1︡{"done":true}
︠e1f8f2be-12f3-488e-b8dc-2036083b1c13s︠
#//Input:lists vec1 and vec2 of length 2
#//Output: ?
vec1=[1,5];V=vector(vec1);type(V)
def angle_and_proj(vec1,vec2):#vec1 and
    u=vector(vec1)
    v=vector(vec2)
    c=N(len(u));l2=N(len(v)) #norms of u and v
    temp=N(u.dot_product(v))# dot product <u,v> converted to the decimal form
    angle=N(u.dot_product(v)) #Complete coding the formula for the angle b/w two vectors
    projection=N(temp/12) # Complete coding the formula for projection of u on the direction of v
    return(angle,projection)
︡69fb2da3-c5f5-46ca-8c84-5cf3b02b18a0︡{"stdout":"<type 'sage.modules.vector_integer_dense.Vector_integer_dense'>\n"}︡{"done":true}
︠ee7d906a-8f7b-4b4e-b426-d6bde82683f0s︠
#Example:
angle, projection=angle_and_proj([3,0],[-3,5]);angle
︡7defd650-f60c-4068-be4c-8a4ec55ccf48︡{"stdout":"-9.00000000000000\n"}︡{"done":true}
︠702cff44-1ba8-4bec-8654-e62f85fdb80as︠
#Exercise 2(a). Make a CAS function pt_line_distance(a, b, c, pt)  that takes coefficients #a, b, c of the general equation of a line and coordinates pt = [x0, y0] of a point and returns the distance from the point to the line.
#(b) Make up an example and test your code using the example. Plot in one figure (i) the point, (ii) #the line, and (iii) a vector perpendicular to the line with its tail located at the given point.
#//Imput: ?
#//Output:distance from point to line defined by the equation ?
def pt_line_distance(a,b,c,pt):
    if b==0:
           return bas(pt[0]+c/d)
    else:
        n=vector([a,b]).norm()# length of a normal vector to the given line
        dist=(abs(a*pt[0]+b*pt[0]+c))/n#Encode the distance formula
        return dist
pt_line_distance(1,2.3,-1,[1,1.])
︡03d2a42b-c59d-4c1d-a221-bfc4453e0ac9︡{"stdout":"0.917070056253235\n"}︡{"done":true}
︠ac07539a-c0e3-4b74-afae-51f5775704e5s︠
# Execise 2(b): Plotting
#//Input:?
#//Output:?
def ex2_plot(a,b,c,pt):
    line_plot=plot((-a/b)*x-(c/b),pt[0]-3,pt[0]+3.,figsize=[4,3])# the range for x can be chosen differently
    pt_plot=point(pt,size=30,color='green',figsize=[4,3])
    n_plot=arrow((pt[0],pt[1]),(pt[0]+a,pt[1]+b))
    G=line_plot+pt_plot+n_plot
    G.show()



ex2_plot(1,2.3,-1,[1,1.])
︡df6914a3-6c51-4c39-a865-47e698e42e5f︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/353/tmp_eQI_Ka.svg","show":true,"text":null,"uuid":"ac272c2c-0a7b-4cee-baa2-5cece08ebd0c"},"once":false}︡{"done":true}
︠5ad0919d-6e8b-4440-83c7-1ffacdfedc42︠
#Exercise 3: Make a CAS function three_motions(pt, t, V, param) that takes coordinates pt  of a point, angle t, in radians, vector V,and parameter p. Your function should return a plot of the given point and its image under the following transformations:
#(a) translation defined by the vector V  if p = 0;
#(b) rotation defined by the angle t if p = 1;
#(c) reflection of the point in the y-axis if p = 2;
#Test you code for specific transformations of each of the three kinds of motions.

                   # Make this function w/out my template
︡bd87fdb3-166a-48a1-9b76-0331a36b0b0b︡
︠d09b5351-20ea-49a7-8550-ed9d6ab1f60fs︠

︡817ee645-42d9-4837-bb3d-342f6e06f534︡{"done":true}
︠1ecffac4-44c1-4ad5-b56c-44a33fc46c6cs︠
def three_motions(pt,t,v,p):
    if p==0:
        pt_image=(pt[0]+v[0],pt[1]+v[1])
    elif p==1:
        a=cos(t);b=sin(t)
        pt_image=(a*pt[0]+b*pt[1],-b*pt[1]+a*pt[0])
    else:
         pt_image=(-pt[0],pt[1])
    return pt_image

three_motions([3,5],.8,vector([3,4]),0)
︡f8559c1e-3af0-4e4c-aa94-fbdb6575cf23︡{"stdout":"(6, 9)\n"}︡{"done":true}
︠c449de31-acef-4167-a90b-bb14accc8c0b︠
#Exercise 7 (demo). Use CAS to substitute the expressions x = X*cos(t)-Y*sin(t), y = X*sin(t)+Y*cos(t) into the equation A*x^2+2*B*x*y+C*y^2=1. Find the coefficient of X*Y.
var('A B C x y t X Y')
expr=A*x^2+2*B*x*y+C*y^2
x = X*cos(t)-Y*sin(t)
y = X*sin(t)+Y*cos(t)


︡2cbd62b6-8b08-4bc5-96f8-e9f0df9de865︡{"stdout":"(A, B, C, x, y, t, X, Y)\n"}︡{"done":true}
︠947ae465-61dd-4278-beaa-2e6e68df1446︠

expr1=expr.subs(x = X*cos(t)-Y*sin(t), y = X*sin(t)+Y*cos(t))
︡eba7b204-6728-43ba-b06a-9765418a5585︡{"done":true}
︠0a906d88-e919-4f89-b0a1-7ae8016d5d64︠
expr2=expand(expr1);expr2
︡18530231-a687-4a8d-a3e0-78276ae4368e︡{"stdout":"A*X^2*cos(t)^2 + 2*B*X*Y*cos(t)^2 + C*Y^2*cos(t)^2 + 2*B*X^2*cos(t)*sin(t) - 2*A*X*Y*cos(t)*sin(t) + 2*C*X*Y*cos(t)*sin(t) - 2*B*Y^2*cos(t)*sin(t) + C*X^2*sin(t)^2 - 2*B*X*Y*sin(t)^2 + A*Y^2*sin(t)^2\n"}︡{"done":true}
︠6bf4bec7-a1b9-4b3c-b510-e7df7e480e56s︠
expr3=(expr2.coefficient(X,n=1))/2;expr3
︡10e8157c-900e-418a-a615-005c61b6bca6︡{"stdout":"B*Y*cos(t)^2 - A*Y*cos(t)*sin(t) + C*Y*cos(t)*sin(t) - B*Y*sin(t)^2\n"}︡{"done":true}
︠96a9e3bb-3bd5-49da-821d-32bfa878f8cfs︠
expr3.coefficient(Y,n=1)
︡8869ff11-7f88-4919-b0fe-b2269cb24501︡{"stdout":"B*cos(t)^2 - A*cos(t)*sin(t) + C*cos(t)*sin(t) - B*sin(t)^2\n"}︡{"done":true}
︠bf63bcb5-23ca-42eb-91c6-46c360a74f69︠
#Manual solution of the equation (A-C)*sin(2*t)=2*B*cos(2*t): cot(2*t)=(A-C)/2*B.










